/*	COEF.C
	reads coefficient data file and creates an assembler data module
	original modules written by Mike Early				 7/29/87
	assembler output added by Phil Davidson			10/27/87
*/

#include	<stdio.h>						/* Standard I/O header file	*/

#define	CR  '\x0D'

FILE	*fpin;								/* Pointer to the input file	*/
FILE	*fpout;								/* Pointer to the output file	*/

char Set[3];

/****************************  main  program  ******************************/
main (argc,argv)
	int	argc;
	char   *argv [];

	{
	char FileIn[24];
	int i,c,eols,row,col,field;
	int num_exa_coef;
	char coef_exact[200][14];

	if ( argc > 1 )
		{
		strcpy ( FileIn, &argv[1][0] );
		}
	else
		{
		printf ( "\n\nEnter the name of the file to be checked -> " );
		scanf ( "%24s", FileIn );
		}
	printf ("\n");

	if ( argc > 2 )
		{
		strcpy ( Set, &argv[2][0] );
		}
	else
		{
		printf ( "\n\nEnter the set number for the file to be created -> " );
		scanf ( "%2s", Set );
		}
	printf ("\n");

				/*  open input file 	 */
	if (( fpin = fopen(FileIn, "rb")) == NULL )
		{
		printf( " ******  there has been an error opening %s for input  *****",FileIn);
		exit(1);
		}

		/*  read thru input till get 'EXA' characters after an 0x0d,0x0a	*/
	find_exa ();


       
	i=0;		/*  read till get two eols in a row, data fields start next	*/
	do
		{
		if ( (c = getc (fpin )) == 0x0d )
			{
         i++;
			c = getc (fpin);
			}
		else
			{
			i = 0;
			}
		}
	while ( i < 2 );

		/*  read data fields till get two eols in a row, that is end of data  */
		/*  row is the coef number, col is pos within coef field  */
	eols = 0;
	row = 1;
	col = 0;
	skip_spaces ();
	do
		{
		if ( (c=getc(fpin)) == 0x0d )
			{
         eols++;
			c = getc(fpin);
			}
		else
			{
			eols = 0;
			if ( c == 0x20 )
				{
				coef_exact [row] [col] = 0x00;
				col=0;
				row++;
				skip_spaces ();
				}
			else
				{
				coef_exact [row] [col++] = c;
				}
			}
		}
	while ( eols < 2 );
	num_exa_coef = row;


				/* close input, convert to hex */
	fclose (fpin);
	coef_dat(coef_exact,num_exa_coef);
	exit (0);
	}
/****************************  end of main  ********************************/


/****************************  find_exa ()  ********************************/
/*		finds the next occurance of '0x0d,0x??,0x45,0x58,0x41'
			"EXA" after a <cr>,  where fpin is the input file
*/

find_exa ()

   {
   char c,d;

   do
		{
		do
			{
			if (( c = getc( fpin )) == EOF )
				{
				fclose(fpin);
				printf("\n  error --  EOF too soon in input file  ");
				exit(1);
				}
			}
		while ( c != 0x0D );

		d = getc ( fpin );
		d = getc ( fpin );
		if ( d == 0x45 ) 
			{
			d = getc ( fpin );
			if ( d == 0x58 )
				{
				d = getc ( fpin );
				if ( d == 0x41 )
					{
					break;
					}
				else
					{
					ungetc(d,fpin);
					}
				}
			else
				{
				ungetc(d,fpin);
				}
			}
		else
			{
			ungetc(d,fpin);
			}
		}
	while (1);
	}
/***************************  end of find_exa()  ***************************/


/****************************  skip_spaces ()   ****************************/
/*		skips over spaces ( 0x20 ) from the input file 'fpin'
			leaving the filepointer set to get the next character.
*/

skip_spaces ()
   
   {
   char  c;
/*  printf ("skip\n");  */

   do
      {
      c = getc (fpin);
/*  printf ("%c", c);  */
      }
   while ( c == 0x20 );
   ungetc ( c, fpin);
   }
/***************************  end of skip_spaces ()  ***********************/

/***************************       coef_dat ()       ***********************/
/*  coef_dat ()      create correctly formatted coef??.src file for 
                     linking coefficient sets with assembler programs.
                     each output coef is an 8 digit hex number.

                     where coef_in is array of strings, which are the 
                     coefficiemts in form -0.000000 , and 
                     num_coef is number of array members, which is 
                     such that the actual number of coefs for a filter
                     is equal to (2 * num_coef - 1), coefs are semetrical 
                     about the last member of the array of coef_in.

*/

coef_dat (coef_in,num_coef)

	char coef_in[][14];
	int num_coef;

	{

	long  	coef_out[200][2];
	char		FileOut[12];
	double	*output,
				one,
				dtemp;
	int		negative;   /* not 0 for neg, 0 for positive */
	long		lint;
	int		i,j,elt;
	char		header[150];


	one = 1.0;
	output = &dtemp;

	strcpy(header,"**************\n* COEF");
	strcat(header,Set);
	strcat(header,".SRC *\n**************\n\n\tXDEF\t.coef");
	strcat(header,Set);
	strcat(header,"\n\tSECT\t13\n");

	strcpy(FileOut,"coef");
	strcat(FileOut,Set);
	strcat(FileOut,".src");

				/* open output file */
	if (( fpout = fopen(FileOut, "w")) == NULL )
		{
		printf("\n\n ******  there has been an error opening %s for output  *****",FileOut);
		exit(1);
		}

				/*  prepare to put formatted coef to output file  */
	fprintf ( fpout, "%s\n",header);
	fprintf ( fpout, ".coef%s\tDC.L\t%d\n",Set,(num_coef * 2 - 1));


	for ( elt = 0; elt < num_coef; elt++ )
		{
		sscanf( coef_in[elt+1], "%lf", output );
/*  printf ("\nin=%s, out=%e", coef_in[elt + 1], *output );  */
		negative = ( *output < 0.0 ? 1 : 0 );
		if ( negative )
			{
			*output *= -1.0;
			}
		dtemp = (double)32768 * (*output / one);
		coef_out[elt+1][1] = (long)dtemp;
		dtemp -= coef_out[elt+1][1];
		coef_out[elt+1][0] = (long)65536 * dtemp;
		if ( negative )
			{
			coef_out[elt+1][1] = (long)65535 - coef_out[elt+1][1];
			coef_out[elt+1][0] = (long)65536 - coef_out[elt+1][0];
			}
		fprintf (fpout, "\tDC.L\t$");
		fprintf ( fpout, "%04lX%04lX\n", coef_out[elt + 1][1],
																	coef_out[elt+1][0] );
		}

	for ( elt = ( num_coef - 2 ); elt >= 0; elt-- )
		{
		fprintf (fpout, "\tDC.L\t$");
		fprintf ( fpout, "%04lX%04lX\n", coef_out[elt + 1][1],
																	coef_out[elt+1][0] );
		}
	fprintf (fpout,"\tEND\n");
	fclose ( fpout );

	}
/************************** end of coef_dat () *****************************/

/**************************      power ()      *****************************/
/*  start of power ()         given an int base argument, and a  
                              int power arg, returns the double
                                     (base)^(power)
*/

double power (base,exp)

   int   exp,base;

   {
   double result;
   int   i,neg;

/*  printf ("\n  %d raised to %d, should be ", base, exp );  */
   if ( exp == 0 )
      {
/*  printf ("1");  */
      return ( 1 );
      }
   result = 1;
   if ( exp < 0 )
      {
      neg = 1;
      exp = ( -exp );
      }
   else
      {
      neg = 0;
      }
/*  printf ("  exp is %d  ", exp );  */
   for ( i = 1; i <= exp; i++ )
      {
      result *= base;
      }
   if ( neg )
      {
      result = 1/result;
      }
/*  printf ("%12.4f ", result );  */
      return ( result );
   }

/************************** end of power () ********************************/
