	program msw_prog
c
c ...... write "un-FIR'ed" SASPE data mseed file
c
c  Sample fortran program to read and uncompress data from 
c  a single channel MiniSEED data file.
c
c msw_prog $msw_1 $afile.corr $yr $doy $hr $mn $sc $msec 
c          $stn $net $str $rate $nsamp
c
	implicit none
c
	integer*4 i_yr, i_doy, i_hr, i_mn, i_msec, i_nsamp, i_rate, 
     1    secs, usecs, i_sc
	real*4 f_sc, f_data
	character*80 iafile, clarg
	character*4 a_stn
	character*3 a_str
	character*2 a_net
c
c	include "../qlib2/qlib2.inc"
 	include "/usr/local/include/qlib2.inc"

	integer BLKSIZE, MAXBLKS
	parameter (BLKSIZE = 4096, MAXBLKS = 100)
	character mseed*(BLKSIZE*MAXBLKS)
	integer MAXPTS
	parameter (MAXPTS = 3500000)
	double precision THRESHOLD
	parameter (THRESHOLD = .5)

	record /DATA_HDR/ hdr
	record /INT_TIME/ it
	record /EXT_TIME/ et
	integer data(MAXPTS)
	integer fp, remaining, next, n, i
	integer nsamples, nrecords, nwrite, ndata
	integer seconds, usecs, nargs
	integer my_wordorder
	character*80 file

c external functions and subroutines
	integer iargc
	external getarg, iargc
	integer lnblnk
	external lnblnk 
c functions in qlib2
	integer f_get_my_wordorder, f_mdy_to_doy
	external f_get_my_wordorder, f_mdy_to_doy
	external f_set_hdr_wordorder, f_set_data_wordorder
 	external f_ext_to_int, f_init_data_hdr
	integer f_delete_blockette
	external f_delete_blockette
c functions in library fio.
	integer ifopen, ifclose, ifwrite
	external ifopen, ifclose, ifwrite

	
c read filename from command line argument and open input miniseed file.
	nargs = iargc()
	if (nargs .lt. 13) then
	    write (*,*) "Missing command line arguments"
	    call exit(1)
	endif
	i=1
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(a)') file
	i=2
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(a)') iafile
	i=3
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(i)') i_yr
	i=4
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(i)') i_doy
	i=5
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(i)') i_hr
	i=6
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(i)') i_mn
	i=7
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(i)') i_sc
	i=8
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(i)') i_msec
	i=9
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(a)') a_stn
	i=10
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(a)') a_net
	i=11
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(a)') a_str
	i=12
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(i)') i_rate
	i=13
	call getarg(i,clarg)
	read(clarg(1:lnblnk(clarg)),'(i)') i_nsamp
c
	fp = ifopen (file, "w")
	if (fp .eq. 0) then
		write(*,*) "unable to open file", file
		call exit(1)
	endif

c set number of requested data points.
c NOTE -- buffer must be large enough to handle this many points.
	open(10,file=iafile(1:lnblnk(iafile)),status='old')
	nsamples = i_nsamp
	do i = 1, nsamples
	  read(10,'(f)') f_data
	  data(i)=ifix(f_data)
	end do
	close(10)

c Initialize the desired word order for the data.
	my_wordorder = f_get_my_wordorder()
	call f_set_hdr_wordorder(my_wordorder)
	call f_set_data_wordorder(my_wordorder)
c
c Compute the time of the first sample.
c
	et.year = i_yr
	if(i_yr.eq.1995) then
	  if(i_doy.le.334) then
	    et.month = 11
	    et.day = i_doy-304
	  else
	    et.month = 12
	    et.day = i_doy-334
	  endif
	else
	  if(i_doy.le.31) then
	    et.month = 1
	    et.day = i_doy
	  elseif(i_doy.le.60) then
	    et.month = 2
	    et.day = i_doy-31
	  elseif(i_doy.le.91) then
	    et.month = 3
	    et.day = i_doy-60
	  else
	    et.month = 4
	    et.day = i_doy-91
	  endif
	endif
	et.hour = i_hr
	et.minute = i_mn
	et.second = i_sc
	et.usec = i_msec
	et.doy = f_mdy_to_doy (et.month, et.day, et.year)
	call f_ext_to_int (et, it)
c
c Set up all of the required data in the header.
c
	call f_init_data_hdr (hdr)
	hdr.station_id = a_stn
	hdr.channel_id = a_str
	hdr.network_id = a_net
	hdr.sample_rate = i_rate
	hdr.data_type = STEIM1
	hdr.blksize = 4096

	hdr.hdrtime = it
	hdr.seq_no = 1
	remaining = nsamples
	call f_time_interval ( 25, i_rate, secs, usecs )
	hdr.num_ticks_correction = secs * TICKS_PER_SEC +
     1		(usecs / USECS_PER_TICK)
	hdr.activity_flags = char(0)
	call f_add_time ( it, 0, hdr.num_ticks_correction, hdr.begtime)
c
c Loop over the data, packing it into MiniSEED and writing the 
c MiniSEED records to a file.  Continue until all data is processed.
c You REALLY want the mseed buffer large enough to hold your entire
c data array, since otherwise the MiniSEED compressor restarts
c every time you call it.
c
	do while (remaining .gt. 0)
	    next = nsamples - remaining + 1
	    hdr.num_samples = remaining
c
c Create the MiniSEED data.  If the output buffer is not large enough
c hold the packed MiniSEED for all of the input data, only a portion
c of the data will be packed.  The function will return the number
c of data points packed into the MiniSEED buffer.
c
	    ndata = f_ms_pack_data (hdr, hdr.num_samples, data(next), 
     1				nrecords, mseed, BLKSIZE * MAXBLKS)
c
c Write the MiniSEED data to the file.
c
	    nwrite = ifwrite (mseed, hdr.blksize * nrecords, 1, fp)
	    if (nwrite .ne. 1) then
		write (*,'(A A)') 'Error writing MiniSEED file', file
		call exit (1)
	    endif
	
c
c Update the hdr for the next chunk of data
c
	    call f_time_interval (ndata, hdr.sample_rate, seconds, usecs)
	    call f_add_time(hdr.hdrtime, seconds, usecs, hdr.hdrtime)
	    call f_add_time(hdr.begtime, seconds, usecs, hdr.begtime)
	    n = f_delete_blockette (hdr, -1)
	    remaining = remaining - ndata
	    if (remaining .gt. 0) then
		write (*,'(A,I,A)' ) 'Warning - mseed buffer too small',
     1				   remaining, ' points process next pass.'
	    endif
	end do
c
c CLose the file.
c
	i = ifclose (fp)
c
	stop
	end
