	program firfft
c
c ...... Fourier Spectrum of FIR Filter
c
	implicit none
	integer*4 i, j, nc, np, lnblnk, lnb, narg, iargc, 
     1    system, sps, isign
	real*4 xr(1024), xi(1024), data(2048)
	real*8 fc(1024), amp, freq
	character*80 infile, clarg, bline
c
	narg=iargc()
	i=1
	call getarg(i,clarg)
	lnb=lnblnk(clarg)
	read(clarg(1:lnb),'(i)') sps
	i=2
	call getarg(i,clarg)
	lnb=lnblnk(clarg)
	read(clarg(1:lnb),'(a)') infile
	open(10,file=infile(1:lnb),status='old')
	bline=
     1    "grep fir_coeff "//clarg(1:lnb)//
     2    " | awk '{ print $2 }' > foo_1"
	lnb=lnblnk(bline)
	i=system(bline(1:lnb))
	open(10,file='foo_1',status='old')
c
	i=0
    1   i=i+1
	read(10,'(f)',end=2) fc(i)
	go to 1
    2   continue
	nc=i-1
	close(10)
c
	j=0
	do 3 i=1,nc
	  xr(i)=sngl(fc(i))
	  xi(i)=0.
	  j=j+1
	  data(j)=xr(i)
	  j=j+1
	  data(j)=xi(i)
c	  write(*,*) 'fc(',i,') = ',fc(i)
    3   continue
	do 35 i=nc,1,-1
	  j=j+1
	  data(j)=sngl(fc(i))
c	  write(*,*) 'fc(',2*nc+1-i,') = ',fc(i)
	  j=j+1
	  data(j)=0.
   35   continue
	np=1024
	do 4 i=2*nc+1,np
	  xr(i)=0.
	  xi(i)=0.
	  j=j+1
	  data(j)=xr(i)
	  j=j+1
	  data(j)=xi(i)
    4   continue
c
	isign=-1
	call four1(data,np,isign)
c
	j=0
	do 5 i=1,np,2
	  j=j+1
	  amp=dsqrt(dble(data(i)*data(i))+dble(data(i+1)*data(i+1)))
	  freq=dble(j)/(dble(np)/dble(sps))
	  write(*,'(f10.5,f20.12)') freq,amp
    5   continue
c
	stop
	end

	subroutine four1(data,nn,isign)
c
c ...... discrete fourier transform
c
	real*8 wr, wi, wpr, wpi, wtemp, theta
	real*4 data(2048)
c
	n=2*nn
	j=1
	do 11 i=1,n,2
	  if(j.gt.i) then
	    tempr=data(j)
	    tempi=data(j+1)
	    data(j)=data(i)
	    data(j+1)=data(i+1)
	    data(i)=tempr
	    data(i+1)=tempi
	  endif
	  m=n/2
    1     if((m.ge.2).and.(j.gt.m)) then
	    j=j-m
	    m=m/2
	    go to 1
	  endif
	  j=j+m
   11   continue
	mmax=2
    2   if(n.gt.mmax) then
	  istep=2*mmax
	  theta=6.28318530717959d0/(isign*mmax)
	  wpr=-2.d0*dsin(0.5d0*theta)**2
	  wpi=dsin(theta)
	  wr=1.d0
	  wi=0.d0
	  do 13 m=1,mmax,2
	    do 12 i=m,n,istep
	      j=i+mmax
	      tempr=sngl(wr)*data(j)-sngl(wi)*data(j+1)
	      tempi=sngl(wr)*data(j+1)+sngl(wi)*data(j)
	      data(j)=data(i)-tempr
	      data(j+1)=data(i+1)-tempi
	      data(i)=data(i)+tempr
	      data(i+1)=data(i+1)+tempi
   12       continue
	    wtemp=wr
	    wr=wr*wpr-wi*wpi+wr
	    wi=wi*wpr+wtemp*wpi+wi
   13     continue
	  mmax=istep
	  go to 2
	endif
c
	return
	end
